/* 
   code by la1n.ch
   more details:  "about the source ... " 
*/



/* l1neumView.h */

#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>

#import <Screensaver/ScreenSaver.h>

// sound
#import <Quicktime/Quicktime.h>

// own ..
#import <tpObject.h>
#import <tboBonus.h>
#import <tboEnemy.h>
#import "tboOnFire.h"
#import <tboEnemyBigBoss.h>

#import <objectWall.h>

@interface l1neumView : NSOpenGLView
{
   int colorBits, depthBits;
   BOOL runningFullScreen;
   NSDictionary *originalDisplayMode;
   GLenum texFormat[ 1 ];   // Format of texture (GL_RGB, GL_RGBA)
   NSSize texSize[ 1 ];     // Width and height
   char *texBytes[ 1 ];     // Texture data
   
   
   // -----------------------
   // debug
   // -----------------------
   BOOL debugPlayField;

   BOOL debugRotateF;
   
   BOOL soundEffects;
   
   // --------------------
   // defaults/scores
   // --------------------
   NSUserDefaults *prefs;
   
   // hiscores
   long hiScoresPoints[10];
   NSMutableArray * hiScoresName; 

   BOOL highscoreInsertMode;
   int positionInHighscores;
   NSMutableString * gamerName;
   
   // --------------------
   // systemMode
   // --------------------
   int systemMode;
   int systemModeSub;
   int systemModeSubMode;
   int systemModeSubSettings;
   
   BOOL systemWindowModeBig;
   BOOL systemMusic;
   BOOL systemEmotions;

   long systemModeSubCounter;
   
   // animation
   int animationCounter;
   int animationCounterDirect;
   BOOL animationReverse;
   
   
   // next ..
   int systemModeIntroAutomaticNext;
   
   
   // menuTimer
   // (delay between )
   float menuTimer;
   
   
   // 0 intro
   //   0 - go in with music
   //   1 - display the titlescreen
   //   2 - add "code&design"
   //   3 - add "music.."
   // 1 choice
   //   0 - play
   //   1 - settings
   //   2 - description
   //   3 - highscore
   //   4 - web
   //   5 - quit
   // 2 game
   //   0 startlevel
   //   1 ingame
   //   2 pause
   //   3 
   //   4 endlevel
   //   5 game over
   //	6 game end
   
   // ------------------
   // end of the game
   // ------------------
   int gameVarEndLevel;
   
   // --------------------
   // gameVar
   // --------------------
   int gameVarLevel;
   int gameVarLifes;
   int gameVarRestTime;
   int gameVarTimeout;
	int timeOutCounter;
   
   long gameVarScore;
   
		// values
		long gameVarScoreKilledEnemy;

	int gameVarMaxX;
	int gameVarMaxY;
   
    // the shield is going down
	float shield;
   
   // --------------------
   // graphics
   // --------------------
   // 0 - all
   // 10 - rudiment.
   int graphics;
   
   // --------------------
   // emotion
   // --------------------
   float emotionLevel;

   float emotionLevelA;
   float emotionLevelASpeed;
   float emotionLevelMaxA;
   int emotionLevelADirection;
   float emotionLevelSpeed;

   // X
   float emotionLevelAX;
   float emotionLevelAXSpeed;
   float emotionLevelMaxAX;
   int emotionLevelAXDirection;

   // Y
   float emotionLevelAY;
   float emotionLevelAYSpeed;
   float emotionLevelMaxAY;
   int emotionLevelAYDirection;
   
   
   
   int emotionLevelDirection;
   float emotionLevelMin;
   float emotionLevelDown;
   float emotionLevelMax;
  
   float emotionXA;
   float emotionYA;
   float emotionSpeedX;
   float emotionSpeedY;
   int emotionDirection;
   
   // ----------------------- 
   // musixs
   // -----------------------
   	// object for music
	NSMovie *musicTitleTheme;
	NSMovie *musicInGame;
	
	// effects ..

	// menu
	NSSound *soundMenuNextPoint;
	NSSound *soundMenuPointDone;

	// nextLevel
	NSSound *soundNextLevel;
	

	// sound enemy die
	NSSound *soundEnemyDie;
	NSSound *soundEnemyDieHard;

	// sound enemy big
	NSSound *soundEnemyBigBossStop;
	NSSound *soundBigBossShoot;
	NSSound *soundEnemyBoing;

	// sound vessel die
	NSSound * soundVesselDie;
	NSSound * soundVesselTerrain;
	NSSound * soundVesselNoWay;

	NSSound * soundFireLineEnd;

	// bonus
	NSSound * soundBonusFree;


	// gameOver
	NSSound * soundGameOver;
	
	
	
	
   // -----------------------
   // point position
   // -----------------------
   GLfloat xrot;       // X rotation
   GLfloat yrot;       // Y rotation
   GLfloat zrot;       // Z rotation

   GLfloat originxrot;       // X rotation
   GLfloat originyrot;       // Y rotation
   GLfloat originzrot;       // Z rotation
 
   GLfloat xrotstore;       // X rotation
   GLfloat yrotstore;       // Y rotation
   GLfloat zrotstore;       // Z rotation
   
   GLfloat xoffset;       // Z rotation
   GLfloat yoffset;       // Z rotation
   GLfloat zoffset;       // Z rotation

	// -----------------
	// scales
	// -----------------
	float scalePlayFieldX;
	float scalePlayFieldY;
	float scalePlayFieldZ;

	// the height
	int heightFloor;
	int heightTopFloor;

   // -------------------
   // playfield
   // -------------------
    int playField[420][420];

	// 0 - empty
    // 1 - normal
    // 2 - secure line
    // 3 - line in enmeies field
	
	// functions for .. fill
	// 4 - fill done
	// 5 - fill to do
	
	// 6 - used for generating fireline
	
	// 7 - 1 generating flatboxes
	// 8 - 2					 firelines
	
	// 9 - project bonusObjects
	
	// 20- old secret lines
	
	
	// size of the playground
	int playFieldCountX;
    int playFieldCountY;
   
    // helping things 
	// representation
	int oldPositionX;
	int oldPositionY;
   
    // levelspec
	// flatcounter
	int flat; 
	long dotesCount;
	
	// fog
	BOOL fogFlag;
   
	
   	// ----------------
	// objects
	// ----------------
	NSMutableArray * objects;
	
	// minimal things
	tpObject * representation;
	tboEnemyBigBoss * enemyBoss;
	int enemyBigWidth;
	int enemyBigHeight;
	
	int enemyWidth;
	int enemyHeight;

	int enemyFlyWidth;
	int enemyFlyHeight;
	
	int enemyShootType;
	
	tboOnFire * enemyRunner1;
	tboOnFire * enemyRunner2;
	
	BOOL soundTitlePlay;
	
	// enemy vars
	BOOL enemyBossShoot;
	float speedFlyingEnemy;
	
   	// ----------------
	// walls
   	// ----------------
	// walls will be generated of playfield
	NSMutableArray * walls;
	
	
   	// ----------------
	// textures
	// ----------------
	GLuint textureArray[ 130 ];     // Storage for all textures
    // textureIndex
	int textureIndex;
     
    // texture
	int textureChars;
	
	int textureBackground;
	int textureLogo;
	int textureScore;
	
	int textureLogoBackground;
	int textureFireLine;
	int textureShipBackground;
	int textureShipBackgroundFireLine;

	// walls
	int textureWallTop;
	int textureWallFront;
	int textureWallSide;

	// title
	int textureTitle;
	int textureTitleCredits;

	// menu
	int textureMenu;
	int textureMenuItems;

	int textureMenuSubSettings;
	int textureMenuSubRulez;
	int textureMenuSubHighscore;
	int textureMenuSubHighscoreInsert;


	// in game
	int textureGameBackground;
	int textureGameActualLevel;
	float textureGameActualLevelTransparent;
	BOOL textureGameActualLevelEnableTransparent;
	int textureGameNextLevel;

	// menu
	int textureGameOver;
	int textureFinished;

	
	// enemy
	int textureEnemy;
	int textureEnemyBigBoss;
	int textureEnemyFly;
	
	// bonus
	int textureBonus;
	int textureBonusBase;
	
	// bonusFlags
	float bonusShield;
	float bonusTimeout;
	float bonusSpeedup;
	
	// representation
	int textureRepresentation;
	int textureRepresentationShield;
	
	// paused
	int texturePaused;
	int texturePausedExit;
	
	int textureHunter;
	
	
	// numbers / alpha
	int textureNumber;
	
	// percent
	float percent;
	
	
	BOOL displayFireLineVertical;
	
		
    // -----------------
	// keys
    // -----------------
	// left/right
	BOOL statusMove1;
	BOOL statusMove2;
	// up&down 
	BOOL statusMove3;
	BOOL statusMove4;
	BOOL statusFire;
	
	int keyCounter;
	
	// ----------------
	// soundEffects
	// ----------------
	NSMutableArray * soundEffectsArray;
	NSMutableArray * soundEffectsName;
	

}

- (id) initWithFrame:(NSRect)frame colorBits:(int)numColorBits
       depthBits:(int)numDepthBits fullscreen:(BOOL)runFullScreen;
- (void) reshape;
- (void) drawRect:(NSRect)rect;
- (BOOL) isFullScreen;
- (BOOL) setFullScreen:(BOOL)enableFS inFrame:(NSRect)frame;
- (void) dealloc;

// defaults
- (void) setUserDefaults: (NSUserDefaults *) iprefs;

// keys
- (void) keyDownDirect: (unichar) unicodeKey;
- (void) setKeyStatus: (int)moveid value:(BOOL)value;
- (void) doAction: (BOOL) stat;

// game
- (void) doThreadObjects;

// action representation
- (void) move;

// projectBonusObjectsToPlayField
- (void)  projectBonusObjectsToPlayField;
// removeBonusObjectsToPlayField
- (void)  removeBonusObjectsToPlayField;

// display
- (float) convertPositionX:(int) arg;
- (float) convertPositionY:(int) arg;
- (float) convertPositionZ:(int) arg;
// convertSizeX
- (float) convertSizeX:(int) arg;
// convertSizeY
- (float) convertSizeY:(int) arg;
// convertSizeZ
- (float) convertSizeZ:(int) arg;

// level
- (void) resetLevel;

// addWall + flat
- (void) addObjectWall:(int)x y:(int)y xx:(int)xx yy:(int)yy type:(int)type flat:(int)flat;
// addWall
- (void) addObjectWall:(int)x y:(int)y xx:(int)xx yy:(int)yy type:(int)type;
			
// displayFlat
- (void) displayFlat:(float)tx y:(float)ty z:(float)tz xx:(float)txx yy:(float)tyy  zz:(float)tzz;	
- (void) displayFlatExt:(int)tx y:(int)ty z:(int)tz xx:(int)txx yy:(int)tyy  zz:(int)tzz;

// ----------------------
// soundeffect center
// ----------------------
- (void) playSoundEffect:(NSString *)nsstringSoundx;
	
@end
